Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1691240 - Service retirement
Summary: Service retirement
Keywords:
Status: ON_DEV
Alias: None
Product: Red Hat CloudForms Management Engine
Classification: Red Hat
Component: Documentation
Version: 5.10.0
Hardware: x86_64
OS: Unspecified
unspecified
high
Target Milestone: GA
: cfme-future
Assignee: Suyog Sainkar
QA Contact: Red Hat CloudForms Documentation
Red Hat CloudForms Documentation
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-03-21 08:44 UTC by Dmitry Shevrin
Modified: 2019-04-11 03:13 UTC (History)
12 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Category: ---
Cloudforms Team: ---
Target Upstream Version:


Attachments (Terms of Use)

Comment 5 Tina Fitzgerald 2019-03-21 11:00:25 UTC
Hi Dmitry,

The logs provided don't show any reference to the retirement request(1000000000254) specified in the case, or
 the retirement state machine running at all. 

The logs show the scheduled retirement_check running:
evm.log:[----] I, [2019-03-21T18:11:03.173836 #906:12ccf58]  INFO -- : MIQ(MiqGenericWorker::Runner#get_message_via_drb) Message id: [1000000596398], MiqWorker id: [1000000000908], Zone: [VMware], Role: [], Server: [], MiqTask id: [], Ident: [generic], Target id: [], Instance id: [], Task id: [], Command: [RetirementManager.check], Timeout: [600], Priority: [90], State: [dequeue], Deliver On: [], Data: [], Args: [], Dequeued in: [4.060630185] seconds

There are a few ways retirement can be initiated: 
1. The user selecting retire from the UI(Services and VMs).
2. Scheduled retirement(the log snippet above) The retirement_check runs frequently and initiates retirement for any Service/VM that is due for retirement. 

Even though Services have retirement dates, the underlying VM's can have different retirement dates(can be specified during provisioning), and can retire separately, when the retirement date has past(through the scheduled retirement).

When a Service has a retirement_state of 'retiring', it means that the retirement process has already been initiated, and it will not allow another retirement process to proceed.  The retirement state machine will attempt 100 retries to fully retire the service, and will set the retirement state to 'retired' if successful, and 'error' if not. The 'error' condition allows for the retirement to be initiated again.

I see that your custom method is calling: $evm.root["service"].retire_service_resources. This is old code and will not do anything. Retirement now uses request/tasks to process retirement. You should modify the service approval state machine if you want to stop or delay retirement processing. Once the service retirement request is approved, tasks for all service resources(including VMs) will be processed, which is likely why the VMs are retired and the Service is not.

I hope this helps.

Thanks,
Tina

Comment 7 Tina Fitzgerald 2019-03-21 14:05:35 UTC
Hi Dmitry,

You should be able to search the log files for the first time the service entered retirement. You could provide those logs which will tell us how, and when, the service first entered retirement.

The new retirement as a request uses a similar approach as in provisioning where a request is created, approved, and is processed. If you want to stop or delay a retirement, the place to do it is in the service retirement approval class:
/ManageIQ/Service/Retirement/StateMachines/ServiceRetirementRequestApproval 

I'm not sure what documentation we have about enhanced retirement, but I'll look into it.

Thanks,
Tina

Comment 8 Tina Fitzgerald 2019-03-21 15:32:57 UTC
Documentation Question:

Retirement as a request was added in 5.10. Do we have any documentation about the enhanced retirement which creates a request/tasks similar to the provisioning workflow.  If not, I would be happy to work with you and answer any questions.

Comment 9 Tina Fitzgerald 2019-03-25 16:12:58 UTC
Hi Dmitry,

I'm assigning this ticket to documentation. There's nothing to be done here without logs and/or additional information.

Thanks,
Tina

Comment 10 Karie 2019-04-05 20:07:42 UTC
Suyog

Can you follow up with Tina Fitzgerald on anything that needs to be added to the 5.10 documentation.

Thanks
Karie


Note You need to log in before you can comment on or make changes to this bug.